-- Made by GreenHouse! for the FearlessRevolution Forum.
-- Version 1.0

local function FindForm(name)
   for i = 0,GetFormCount()-1 do
      local form = GetForm(i)
      if form.ClassName== name then
         return form
      end
   end
end

regSettings=getSettings('GreenH')
if #regSettings['delSymbolsActive'] == 0 then regSettings['delSymbolsActive'] = 1 end --If it doesn't exist, then create and set to default
delSymbolsActive = tonumber(regSettings['delSymbolsActive']) --Then load the saved setting
if #regSettings['delAdvOptionsActive'] == 0 then regSettings['delAdvOptionsActive'] = 1 end
delAdvOptionsActive = tonumber(regSettings['delAdvOptionsActive'])
if #regSettings['delCommentsActive'] == 0 then regSettings['delCommentsActive'] = 1 end
delCommentsActive = tonumber(regSettings['delCommentsActive'])
if #regSettings['delStructsActive'] == 0 then regSettings['delStructsActive'] = 1 end
delStructsActive = tonumber(regSettings['delStructsActive'])

ExtForm = createForm(false)
ExtForm.Width = 250
ExtForm.Height = 120
ExtForm.Caption = 'Table Cleaner'
ExtForm.OnClose = function() ExtForm.Hide() end
ExtForm.OnShow = function()
checkbox_setState(ExtFormChck1,delSymbolsActive)
checkbox_setState(ExtFormChck2,delAdvOptionsActive)
checkbox_setState(ExtFormChck3,delCommentsActive)
checkbox_setState(ExtFormChck4,delStructsActive)
end

ExtFormChck1 = createCheckBox(ExtForm)
ExtFormChck1.Left = 5
ExtFormChck1.Top = 5
ExtFormChck1.Name = 'delSymbols'
ExtFormChck1.Caption = 'Delete Symbols'
ExtFormChck1.Font.Size = 10
ExtFormChck1.OnClick = function()
  delSymbolsActive = checkbox_getState(ExtFormChck1)
  regSettings.Value['delSymbolsActive']=delSymbolsActive
end
ExtFormChck2 = createCheckBox(ExtForm)
ExtFormChck2.Left = 5
ExtFormChck2.Top = 25
ExtFormChck2.Name = 'delAdvOptions'
ExtFormChck2.Caption = 'Delete Advanced Options'
ExtFormChck2.Font.Size = 10
ExtFormChck2.OnClick = function()
  delAdvOptionsActive = checkbox_getState(ExtFormChck2)
  regSettings.Value['delAdvOptionsActive']=delAdvOptionsActive
end
ExtFormChck3 = createCheckBox(ExtForm)
ExtFormChck3.Left = 5
ExtFormChck3.Top = 45
ExtFormChck3.Name = 'delComments'
ExtFormChck3.Caption = 'Delete Comments'
ExtFormChck3.Font.Size = 10
ExtFormChck3.OnClick = function()
  delCommentsActive = checkbox_getState(ExtFormChck3)
  regSettings.Value['delCommentsActive']=delCommentsActive
end
ExtFormChck4 = createCheckBox(ExtForm)
ExtFormChck4.Left = 5
ExtFormChck4.Top = 65
ExtFormChck4.Name = 'delStructs'
ExtFormChck4.Caption = 'Delete Structures'
ExtFormChck4.Font.Size = 10
ExtFormChck4.OnClick = function()
  delStructsActive = checkbox_getState(ExtFormChck4)
  regSettings.Value['delStructsActive']=delStructsActive
end

ExtFormBttn = createButton(ExtForm)
ExtFormBttn.Left = 5
ExtFormBttn.Top = 90
ExtFormBttn.Name = 'doCleanupBttn'
ExtFormBttn.Caption = 'Clean'
ExtFormBttn.OnClick = function()
AddressList.disableAllWithoutExecute() --Force Disable All Scripts
if delSymbolsActive == 1 then
  MemBrwsr = FindForm('TMemoryBrowser')
  MemBrwsr.miUserdefinedSymbols.doClick()
  SymbHndlr = FindForm('TfrmSymbolhandler')
  local list = SymbHndlr.ListView1.Items
  for i = SymbHndlr.ListView1.Items.Count-1,0,-1 do
  unregisterSymbol(SymbHndlr.ListView1.Items[i].Caption)
  end
  SymbHndlr.Close()
end
if delAdvOptionsActive == 1 then
   FindForm('TAdvancedOptions').lvCodelist.Items.Clear()
end
if delCommentsActive == 1 then
  Cmnts = FindForm('TComments')
  Cmnts.Memo1.Clear()
  MainForm.CommentButton.Font.Style = ''
end
if delStructsActive == 1 then
   if getStructureCount() ~= 0 then
      for i = getStructureCount()-1,0,-1 do
         getStructure(i).removeFromGlobalStructureList()
      end
   end
end
end

if CleanerMenu == nil then
CleanerMenu = createMenuItem(MainForm.Menu)
CleanerMenu.Caption = 'GreenHouse'
MainForm.Menu.Items.insert(MainForm.Menu.Items.Count-1, CleanerMenu)
CleanerMenuItem = createMenuItem(CleanerMenu)
CleanerMenuItem.Caption = 'Clean Table'
CleanerMenuItem.OnClick = function() ExtForm.Show() end
CleanerMenuItem.Name = 'ghCleanTable'
CleanerMenuItem.Shortcut = 'Ctrl+Q'
CleanerMenu.Add(CleanerMenuItem)
end